<?php

namespace Tests\Fakes;

use App\Console\Commands\GoogleWorkspaceUserDeprovision;
use Glamstack\GoogleWorkspace\ApiClient as WorkspaceApiClient;
use Glamstack\Okta\ApiClient as OktaApiClient;
use Symfony\Component\Console\Output\ConsoleOutput;

class GoogleWorkspaceDeprovisionFake extends GoogleWorkspaceUserDeprovision
{

    public function setUp(){
        $this->output = new ConsoleOutput();

        config(['glamstack-okta.auth.default_connection' => 'test']);
        config(['glamstack-okta.connections.test.base_url' => env('OKTA_TEST_BASE_URL')]);
        config(['glamstack-okta.connections.test.api_token' => env('OKTA_TEST_API_TOKEN')]);

        $this->google_workspace_api = new WorkspaceApiClient(null, [
            'api_scopes' => [
                'https://www.googleapis.com/auth/admin.directory.user',
                'https://www.googleapis.com/auth/drive',
                'https://www.googleapis.com/auth/apps.licensing',
                'https://www.google.com/m8/feeds/contacts/',
                'https://www.googleapis.com/auth/admin.directory.group',
                'https://www.googleapis.com/auth/admin.directory.user.security',
            ],
            'json_key' => env('GOOGLE_WORKSPACE_TEST_JSON_KEY'),
            'log_channels' => ['single'],
            'customer_id' => env('GOOGLE_WORKSPACE_TEST_CUSTOMER_ID'),
            'domain' => env('GOOGLE_WORKSPACE_TEST_DOMAIN'),
            'subject_email' => env('GOOGLE_WORKSPACE_TEST_SUBJECT_EMAIL')
        ]);

        $this->user_workspace_api = new WorkspaceApiClient(null,
            [
                'api_scopes' => [
                    'https://www.googleapis.com/auth/gmail.settings.sharing',
                    'https://www.googleapis.com/auth/gmail.settings.basic',
                    'https://www.googleapis.com/auth/drive',
                    'https://www.googleapis.com/auth/calendar'
                ],
                'json_key' => env('GOOGLE_WORKSPACE_TEST_JSON_KEY'),
                'log_channels' => ['single'],
                'customer_id' => env('GOOGLE_WORKSPACE_TEST_CUSTOMER_ID'),
                'domain' => env('GOOGLE_WORKSPACE_TEST_DOMAIN'),
                'subject_email' => env('GOOGLE_WORKSPACE_TEST_USER')
            ]
        );

        $this->okta_api = new OktaApiClient(null, [
            'base_url' => env('OKTA_TEST_BASE_URL'),
            'api_token' => env('OKTA_TEST_API_TOKEN'),
            'log_channels' => ['single']
        ]);
    }

    public function getAccountInformation(string $email): object
    {
        return parent::getAccountInformation($email); // TODO: Change the autogenerated stub
    }

    public function moveAccountOU(string $user, string $target_ou) : object
    {
        return parent::moveAccountOU($user, $target_ou); // TODO: Change the autogenerated stub
    }

    public function resetAccountPassword(string $user): object
    {
        return parent::resetAccountPassword($user); // TODO: Change the autogenerated stub
    }

    public function removeAccountFromGlobalAddress(string $user): object
    {
        return parent::removeAccountFromGlobalAddress($user); // TODO: Change the autogenerated stub
    }

    public function removeAccountRecoveryEmail(string $user): object
    {
        return parent::removeAccountRecoveryEmail($user); // TODO: Change the autogenerated stub
    }

    public function removeAccountRecoveryPhone(string $user): object
    {
        return parent::removeAccountRecoveryPhone($user); // TODO: Change the autogenerated stub
    }

    public function listAllAssignedGroups(string $user): object
    {
        return parent::listAllAssignedGroups($user); // TODO: Change the autogenerated stub
    }

    public function getMangerInformation(string $manager_email): object
    {
        return parent::getMangerInformation($manager_email); // TODO: Change the autogenerated stub
    }

    public function removeAccountFromGroups(string $user, object $group): object
    {
        return parent::removeAccountFromGroups($user, $group); // TODO: Change the autogenerated stub
    }

    public function createVacationMessageBody(string $manager_name, string $manager_email) : string
    {
        return parent::createVacationMessageBody($manager_name, $manager_email); // TODO: Change the autogenerated stub
    }

    public function createVacationMessageSubject(string $user_full_name): string
    {
        return parent::createVacationMessageSubject($user_full_name); // TODO: Change the autogenerated stub
    }

    public function updateVacationMessage(string $user, string $manager, string $user_full_name, string $manager_full_name): object|string
    {
        return parent::updateVacationMessage($user, $manager, $user_full_name, $manager_full_name); // TODO: Change the autogenerated stub
    }

    public function signoutAccount(string $user): object
    {
        return parent::signoutAccount($user); // TODO: Change the autogenerated stub
    }

    public function getDriveFiles(): object
    {
        return parent::getDriveFiles(); // TODO: Change the autogenerated stub
    }

    public function grantEditorAccessToFiles(string $file_id, string $manager_email) : object
    {
        return parent::grantEditorAccessToFiles($file_id, $manager_email); // TODO: Change the autogenerated stub
    }

    public function addManagerAsGmailDelegate(string $delegate_email): object
    {
        return parent::addManagerAsGmailDelegate($delegate_email); // TODO: Change the autogenerated stub
    }

    public function addGmailDelegate(string $delegate_email): object
    {
        return parent::addGmailDelegate($delegate_email); // TODO: Change the autogenerated stub
    }

    public function emailDelegationExists(string $delegate_email): object
    {
        return parent::emailDelegationExists($delegate_email); // TODO: Change the autogenerated stub
    }

    public function removeEmailDelegate(string $delegate_email){
        $this->user_workspace_api->gmail()->delete('/users/me/settings/delegates/' . $delegate_email);
    }

    public function addManagerAsCalendarDelegate(string $delegate_email)
    {
        return parent::addManagerAsCalendarDelegate($delegate_email); // TODO: Change the autogenerated stub
    }

    public function sendSlackMessage(string $channel_id, string $message): bool
    {
        return parent::sendSlackMessage($channel_id, $message); // TODO: Change the autogenerated stub
    }

    public function setManagerSlackMessage(string $mangaer_full_name, string $user_full_name): string
    {
        return parent::setManagerSlackMessage($mangaer_full_name, $user_full_name); // TODO: Change the autogenerated stub
    }

    public function reactivateUserAccount(string $user): object
    {
        return parent::reactivateUserAccount($user); // TODO: Change the autogenerated stub
    }

    public function getTrashedEmails(): object
    {
        return parent::getTrashedEmails(); // TODO: Change the autogenerated stub
    }

    public function trashAnEmailForTesting(): object|string
    {
        $files = $this->user_workspace_api->gmail()->get('/users/me/messages');

        return $this->user_workspace_api->gmail()->post(
            '/users/me/messages/' . $files->object->messages[0]->id . '/trash' );
    }

    public function untrashMessages(object $trashed_messages)
    {
        parent::untrashMessages($trashed_messages); // TODO: Change the autogenerated stub
    }

    public function getTrashedDriveFiles(): object
    {
        return parent::getTrashedDriveFiles(); // TODO: Change the autogenerated stub
    }

    public function trashAFileForTesting(): object|string
    {
        $files = $this->user_workspace_api->drive()->get('/files');
        return $this->user_workspace_api->drive()->patch(
            '/files/' . $files->object->files[0]->id, [
                'trashed' => true
            ]
        );
    }

    public function untrashDriveFiles(object $trashed_files)
    {
        parent::untrashDriveFiles($trashed_files); // TODO: Change the autogenerated stub
    }

    public function apiCallRetry($method, $params)
    {
        return parent::apiCallRetry($method, $params); // TODO: Change the autogenerated stub
    }
}
